Security

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security
Class Security

    java.lang.Object
      java.security.Security

    public final class Security

extends Object

This class centralizes all security properties and common security methods. One of its primary uses is to manage providers.

Version:
  1.101 10/17/00
Author:
  Benjamin Renaud

Method Summary
`static int` | `addProvider(Provider provider)` Adds a provider to the next position available.
`static Set` | `getAlgorithms(String serviceName)` Returns a Set of Strings containing the names of all available algorithms or types for the specified Java cryptographic service (e.g., Signature, MessageDigest, Cipher, Mac, KeyStore).
`static String` | `getProperty(String key)` Gets a security property value.
`static Provider` | `getProvider(String name)` Returns the provider installed with the specified name, if any.
`static Provider[]` | `getProviders()` Returns an array containing all the installed providers.
`static Provider[]` | `getProviders(Map filter)` Returns an array containing all installed providers that satisfy the specified selection criteria, or null if no such providers have been installed.
`static Provider[]` | `getProviders(String filter)` Returns an array containing all installed providers that satisfy the specified selection criterion, or null if no such providers have been installed.
`static int` | `insertProviderAt(Provider provider, int position)` Adds a new provider, at a specified position.
`static void` | `removeProvider(String name)` Removes the provider with the specified name.
`static void` | `setProperty(String key, String datum)` Sets a security property value.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### insertProviderAt

    public static int insertProviderAt(Provider provider,
                                       int position)

  Adds a new provider, at a specified position. The position is the preference order in which providers are searched for requested algorithms. Note that it is not guaranteed that this preference will be respected. The position is 1-based, that is, 1 is most preferred, followed by 2, and so on.

  If the given provider is installed at the requested position, the provider that used to be at that position, and all providers with a position greater than `position`, are shifted up one position (towards the end of the list of installed providers).

  A provider cannot be added if it is already installed.

  First, if there is a security manager, its `checkSecurityAccess` method is called with the string `"insertProvider."+provider.getName()` to see if it's ok to add a new provider. If the default implementation of `checkSecurityAccess` is used (i.e., that method is not overriden), then this will result in a call to the security manager's `checkPermission` method with a `SecurityPermission("insertProvider."+provider.getName())` permission.

  Parameters:
    `provider` - the provider to be added.
    `position` - the preference position that the caller would like for this provider.
  Returns:
    the actual preference position in which the provider was added, or -1 if the provider was not added because it is already installed.
  Throws:
    `SecurityException` - if a security manager exists and its ``SecurityManager.checkSecurityAccess(java.lang.String)`` method denies access to add a new provider
  See Also:
    `getProvider(java.lang.String)`, `removeProvider(java.lang.String)`, `SecurityPermission`

### addProvider

    public static int addProvider(Provider provider)

  Adds a provider to the next position available.

  First, if there is a security manager, its `checkSecurityAccess` method is called with the string `"insertProvider."+provider.getName()` to see if it's ok to add a new provider. If the default implementation of `checkSecurityAccess` is used (i.e., that method is not overriden), then this will result in a call to the security manager's `checkPermission` method with a `SecurityPermission("insertProvider."+provider.getName())` permission.

  Parameters:
    `provider` - the provider to be added.
  Returns:
    the preference position in which the provider was added, or -1 if the provider was not added because it is already installed.
  Throws:
    `SecurityException` - if a security manager exists and its ``SecurityManager.checkSecurityAccess(java.lang.String)`` method denies access to add a new provider
  See Also:
    `getProvider(java.lang.String)`, `removeProvider(java.lang.String)`, `SecurityPermission`

### removeProvider

    public static void removeProvider(String name)

  Removes the provider with the specified name.

  When the specified provider is removed, all providers located at a position greater than where the specified provider was are shifted down one position (towards the head of the list of installed providers).

  This method returns silently if the provider is not installed.

  First, if there is a security manager, its `checkSecurityAccess` method is called with the string `"removeProvider."+name` to see if it's ok to remove the provider. If the default implementation of `checkSecurityAccess` is used (i.e., that method is not overriden), then this will result in a call to the security manager's `checkPermission` method with a `SecurityPermission("removeProvider."+name)` permission.

  Parameters:
    `name` - the name of the provider to remove.
  Throws:
    `SecurityException` - if a security manager exists and its ``SecurityManager.checkSecurityAccess(java.lang.String)`` method denies access to remove the provider
  See Also:
    `getProvider(java.lang.String)`, `addProvider(java.security.Provider)`

### getProviders

    public static Provider[] getProviders()

  Returns an array containing all the installed providers. The order of the providers in the array is their preference order.

  Returns:
    an array of all the installed providers.

### getProvider

    public static Provider getProvider(String name)

  Returns the provider installed with the specified name, if any. Returns null if no provider with the specified name is installed.

  Parameters:
    `name` - the name of the provider to get.
  Returns:
    the provider of the specified name.
  See Also:
    `removeProvider(java.lang.String)`, `addProvider(java.security.Provider)`

### getProviders

    public static Provider[] getProviders(String filter)

  Returns an array containing all installed providers that satisfy the specified selection criterion, or null if no such providers have been installed. The returned providers are ordered according to their preference order.

  A cryptographic service is always associated with a particular algorithm or type. For example, a digital signature service is always associated with a particular algorithm (e.g., DSA), and a CertificateFactory service is always associated with a particular certificate type (e.g., X.509). NOTE: java.security.cert.CertificateFactory is found in J2ME CDC profiles such as J2ME Foundation Profile.

  The selection criterion must be specified in one of the following two formats:

  - <crypto_service>.<algorithm_or_type>

    The cryptographic service name must not contain any dots.

    A provider satisfies the specified selection criterion iff the provider implements the specified algorithm or type for the specified cryptographic service.

    For example, "CertificateFactory.X.509" would be satisfied by any provider that supplied a CertificateFactory implementation for X.509 certificates. NOTE: java.security.cert.CertificateFactory is found in J2ME CDC profiles such as J2ME Foundation Profile.

  - <crypto_service>.<algorithm_or_type> <attribute_name>:< attribute_value>

    The cryptographic service name must not contain any dots. There must be one or more space charaters between the the <algorithm_or_type> and the <attribute_name>.

    A provider satisfies this selection criterion iff the provider implements the specified algorithm or type for the specified cryptographic service and its implementation meets the constraint expressed by the specified attribute name/value pair.

    For example, "Signature.SHA1withDSA KeySize:1024" would be satisfied by any provider that implemented the SHA1withDSA signature algorithm with a keysize of 1024 (or larger). NOTE: java.security.Signature is found in J2ME CDC profiles such as J2ME Foundation Profile.

  See Appendix A in the Java Cryptogaphy Architecture API Specification & Reference for information about standard cryptographic service names, standard algorithm names and standard attribute names.

  Parameters:
    `filter` - the criterion for selecting providers. The filter is case-insensitive.
  Returns:
    all the installed providers that satisfy the selection criterion, or null if no such providers have been installed.
  Throws:
    `InvalidParameterException` - if the filter is not in the required format
  See Also:
    `getProviders(java.util.Map)`

### getProviders

    public static Provider[] getProviders(Map filter)

  Returns an array containing all installed providers that satisfy the specified selection criteria, or null if no such providers have been installed. The returned providers are ordered according to their preference order.

  The selection criteria are represented by a map. Each map entry represents a selection criterion. A provider is selected iff it satisfies all selection criteria. The key for any entry in such a map must be in one of the following two formats:

  - <crypto_service>.<algorithm_or_type>

    The cryptographic service name must not contain any dots.

    The value associated with the key must be an empty string.

    A provider satisfies this selection criterion iff the provider implements the specified algorithm or type for the specified cryptographic service.

  - <crypto_service>.<algorithm_or_type> <attribute_name>

    The cryptographic service name must not contain any dots. There must be one or more space charaters between the <algorithm_or_type> and the <attribute_name>.

    The value associated with the key must be a non-empty string. A provider satisfies this selection criterion iff the provider implements the specified algorithm or type for the specified cryptographic service and its implementation meets the constraint expressed by the specified attribute name/value pair.

  See Appendix A in the Java Cryptogaphy Architecture API Specification & Reference for information about standard cryptographic service names, standard algorithm names and standard attribute names.

  Parameters:
    `filter` - the criteria for selecting providers. The filter is case-insensitive.
  Returns:
    all the installed providers that satisfy the selection criteria, or null if no such providers have been installed.
  Throws:
    `InvalidParameterException` - if the filter is not in the required format
  See Also:
    `getProviders(java.lang.String)`

### getProperty

    public static String getProperty(String key)

  Gets a security property value.

  First, if there is a security manager, its `checkPermission` method is called with a `java.security.SecurityPermission("getProperty."+key)` permission to see if it's ok to retrieve the specified security property value..

  Parameters:
    `key` - the key of the property being retrieved.
  Returns:
    the value of the security property corresponding to key.
  Throws:
    `SecurityException` - if a security manager exists and its ``SecurityManager.checkPermission(java.security.Permission)`` method denies access to retrieve the specified security property value
  See Also:
    `setProperty(java.lang.String, java.lang.String)`, `SecurityPermission`

### setProperty

    public static void setProperty(String key,
                                   String datum)

  Sets a security property value.

  First, if there is a security manager, its `checkPermission` method is called with a `java.security.SecurityPermission("setProperty."+key)` permission to see if it's ok to set the specified security property value.

  Parameters:
    `key` - the name of the property to be set.
    `datum` - the value of the property to be set.
  Throws:
    `SecurityException` - if a security manager exists and its ``SecurityManager.checkPermission(java.security.Permission)`` method denies access to set the specified security property value
  See Also:
    `getProperty(java.lang.String)`, `SecurityPermission`

### getAlgorithms

    public static Set getAlgorithms(String serviceName)

  Returns a Set of Strings containing the names of all available algorithms or types for the specified Java cryptographic service (e.g., Signature, MessageDigest, Cipher, Mac, KeyStore). Returns an empty Set if there is no provider that supports the specified service. For a complete list of Java cryptographic services, please see the Java Cryptography Architecture API Specification & Reference. Note: the returned set is immutable.

  Parameters:
    `serviceName` - the name of the Java cryptographic service (e.g., Signature, MessageDigest, Cipher, Mac, KeyStore). Note: this parameter is case-insensitive. NOTE: java.security.Signature, java.security.KeyStore are found in J2ME CDC profiles such as J2ME Foundation Profile. Cipher, Mac are found in J2ME CDC optional packages such as J2ME Security Optional Package.
  Returns:
    a Set of Strings containing the names of all available algorithms or types for the specified Java cryptographic service or an empty set if no provider supports the specified service.
  Since:
    1.4

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD